/*
CrowlMINIEditor - Kris Merckx 2018
MIT-license
do not remove this copyright notice
*/
var CMECaret = 0;
/*Start cursor*/
function getCaret(element) {
    var caretOffset = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    if (typeof win.getSelection != "undefined") {
        sel = win.getSelection();
        if (sel.rangeCount > 0) {
            var range = win.getSelection().getRangeAt(0);
            var preCaretRange = range.cloneRange();
            preCaretRange.selectNodeContents(element);
            preCaretRange.setEnd(range.endContainer, range.endOffset);
            caretOffset = preCaretRange.toString().length;
        }
    } else if ( (sel = doc.selection) && sel.type != "Control") {
        var textRange = sel.createRange();
        var preCaretTextRange = doc.body.createTextRange();
        preCaretTextRange.moveToElementText(element);
        preCaretTextRange.setEndPoint("EndToEnd", textRange);
        caretOffset = preCaretTextRange.text.length;
    }
    return caretOffset;
}

/*https://github.com/yabwe/medium-editor/issues/730*/
 function setCaret(el, caretPosition) {
            el.focus();

            var range = document.createRange(),
                    sel;

            range.selectNodeContents(el);

            function findTargetNode(node) {
                // console.log('node.nodeType = %d, caretPosition = %d.', node.nodeType, caretPosition, node);

                if (node.nodeType > 3) {
                    // Only iterate over elements and text nodes.
                    return;
                }

                // If we hit a text node, we need to add the
                // amount of characters to the overall count.
                if (node.nodeType === 3) {
                    // console.log('node.length', node.length);

                    if (node.length > caretPosition) {
                        return {
                            node: node,
                            offset: caretPosition
                        };
                    } else if (node.length == caretPosition) {
                        return {
                            node: node,
                            offset: 0
                        };
                    } else {
                        caretPosition -= node.length;
                    }
                }
                // Otherwise, the `nodeType = 1` meaning it is a node.

                for (var i = 0, nodeObj; i < node.childNodes.length; ++i) {
                    nodeObj = findTargetNode(node.childNodes[i]);

                    if (nodeObj) {
                        return nodeObj;
                    }
                }
            }

            switch (caretPosition) {
                case -1:
                    // `-1` caret position indicates that we need
                    // to position the caret at the end of the section.

                    // Passing `false` to `collapse` sets the start
                    // and end points at the same end position.
                    range.collapse(false);
                    break;
                case 0:
                    // `0` caret position indicates that we need
                    // to position the caret at the start of the section.

                    // Passing `true` to `collapse` sets the start
                    // and end points at the same start position.
                    range.collapse(true);

                    break;
                default:
                    // Otherwise, position the caret at the specific
                    // index.
                    var nodeObj = findTargetNode(el);

                    // console.log('nodeObj', nodeObj);

                    if (nodeObj) {
                        range.setStart(nodeObj.node, nodeObj.offset);
                        range.setEnd(nodeObj.node, nodeObj.offset);
                    }
            }

            sel = window.getSelection();

            sel.removeAllRanges();
            sel.addRange(range);
     return true;
}

/*https://stackoverflow.com/questions/6690752/insert-html-at-caret-in-a-contenteditable-div*/
function pasteCaret(html, selectPastedContent) {
    var sel, range;
    if (window.getSelection) {
        // IE9 and non-IE
        sel = window.getSelection();
        if (sel.getRangeAt && sel.rangeCount) {
            range = sel.getRangeAt(0);
            range.deleteContents();

            // Range.createContextualFragment() would be useful here but is
            // only relatively recently standardized and is not supported in
            // some browsers (IE9, for one)
            var el = document.createElement("div");
            el.innerHTML = html;
            var frag = document.createDocumentFragment(), node, lastNode;
            while ( (node = el.firstChild) ) {
                lastNode = frag.appendChild(node);
            }
            var firstNode = frag.firstChild;
            range.insertNode(frag);

            // Preserve the selection
            if (lastNode) {
                range = range.cloneRange();
                range.setStartAfter(lastNode);
                if (selectPastedContent) {
                    range.setStartBefore(firstNode);
                } else {
                    range.collapse(true);
                }
                sel.removeAllRanges();
                sel.addRange(range);
            }
        }
    } else if ( (sel = document.selection) && sel.type != "Control") {
        // IE < 9
        var originalRange = sel.createRange();
        originalRange.collapse(true);
        sel.createRange().pasteHTML(html);
        if (selectPastedContent) {
            range = sel.createRange();
            range.setEndPoint("StartToStart", originalRange);
            range.select();
        }
    }
}



/*Einde cursor*/
                function CEMCreateLink() {
                    var linkURL = prompt('Voer een link in:', 'http://');
                    var newLink = document.execCommand('createlink', false, linkURL);
                    //newLink.target = "_blank";
                }
            var CEMSelectedImg;
            var CEMImageFolder = "";
            var CEMImageDropMultiple = false;
            var CEMImgEditor = function(){
                
            }
            var IMGUPLOADTPL = '\
                <input type="file" id="fileElem" multiple accept="image/*" style="display:none">\
                <button id="UPLFileselect" class="CMEbtn CUPL"><i class="fa fa-camera" aria-hidden="true"></i></button>\
            ';
            
            var IMGEDITORTPL = "\
                            <button class='REMOVEIMG' style='float:right;'>Verwijder</button>\
                            <label>Uitlijning</label>\
                            <select class='floatstyle' style='width:100%;'>\
                                <option value='none' data-style='float:none;'>Geen omloop</option>\
                                <option value='left' data-style='float:left;margin-right:20px;'>Links, tekst rechts</option>\
                                <option value='right' data-style='float:right;margin-left:20px;'>Rechts, tekst links</option>\
                            </select>\
                            <label>Breedte afbeelding</label>\
                            <select class='imgwidth' style='width:100%;'>\
                                <option data-style='width:100%;'>100%</option>\
                                <option data-style='width:50%;'>50%</option>\
                                <option data-style='width:33%;'>33%</option>\
                                <option data-style='width:25%;'>25%</option>\
                            </select>\
                            <label>Roteer afbeelding</label>\
                            <select class='imgrotate' style='width:100%;'>\
                                <option data-style='transform:;'>Niet</option>\
                                <option data-style='transform:rotate(-90deg);'>Links</option>\
                                <option data-style='transform:rotate(90deg);'>Rechts</option>\
                            </select>\
                            <label>Filtereffecten</label>\
                            <select class='imgfilter' style='width:100%;'>\
                                <option data-style='filter:initial;'>Geen</option>\
                                <option data-style='filter:grayscale(100%);'>Grijstinten</option>\
                                <option data-style='filter:invert(100%);'>Negatief</option>\
                                <option data-style='filter:sepia(100%);'>Sepia</option>\
                                <option data-style='filter:blur(5px);'>Vervagen</option>\
                            </select>\
                            <button class='CLOSEIEMODAL'>SLUIT</button>\
            ";

            var duToImg = function(){
                $(".mysmallcrowleditor").find("img").each(function(){
                    $(this).css("cursor", "pointer");
                    $(this).on("click", function(){
                        CEMSelectedImg = $(this); 
                        var ie = $("<div></div>");
                        ie.addClass("IMGEDITOR");
                        var h = IMGEDITORTPL;
                        //alert(h);
                        ie.html(h);
                        $("body").append(ie);
                        $(".REMOVEIMG").on("click", function(e){
                            CEMSelectedImg.remove();
                            $(this).closest(".IMGEDITOR").remove();
                        });
                        $(".imgwidth, .floatstyle, .imgfilter, .imgrotate").on("change", function(){
                            var f = $(".imgwidth option:selected").attr("data-style");
                            var olds = $(".floatstyle option:selected").attr("data-style");
                            var filter = $(".imgfilter option:selected").attr("data-style");
                            var rotate = $(".imgrotate option:selected").attr("data-style");
                            f = olds + f + filter + rotate;
                            CEMSelectedImg.attr("style", f);
                        });
                        $(".CLOSEIEMODAL").on("click", function(){
                            $(this).closest(".IMGEDITOR").remove();
                        });
                    });
                    var pic= $(this);
					var imgsrc=pic.attr("src");
			        var ch= imgsrc.indexOf("data:");
                    var retextension="jpg";
                    if(ch>-1){
                        var extension= imgsrc.indexOf("image/jpeg");
                        if(extension>-1){
                            retextension="jpg";
                        }
                        extension= imgsrc.indexOf("image/jpg");
                        if(extension>-1){
                            retextension="jpg";
                        }
                        extension= imgsrc.indexOf("image/png");
                        if(extension>-1){
                            retextension="png";
                        }
                        extension= imgsrc.indexOf("image/gif");
                        if(extension>-1){
                            retextension="gif";
                        }
                        $.post("saveimg.php", {
                                imageFolder: CEMImageFolder + "/",
				                imageData : imgsrc,
                                extension: retextension
				            }, function(data) {
                                if(CEMImageFolder.length > 0){
                                    CEMImageFolder = CEMImageFolder + "/";
                                }
								pic.attr("src", CEMImageFolder + data);
				            }
                        );
                    }
                });
            }
            var CEMDrag = function(e) {
                //kill any default behavior
                e.stopPropagation();
                e.preventDefault();
                if(!CEMImageDropMultiple){
                    $(".mysmallcrowlimagedropper").find("img").remove();
                }
            };
            var CEMDrop = function(e) {
                //kill any default behavior
                e.stopPropagation();
                e.preventDefault();
                //console.log(e);
                //get x and y coordinates of the dropped item
                x = e.clientX;
                y = e.clientY;
                //drops are treated as multiple files. Only dealing with single files right now, so assume its the first object you're interested in
                var file = e.dataTransfer.files[0];
                //don't try to mess with non-image files
                if (file.type.match('image.*')) {
                    //then we have an image,

                    //we have a file handle, need to read it with file reader!
                    var reader = new FileReader();

                    // Closure to capture the file information.
                    reader.onload = (function(theFile) {
                        //get the data uri
                        var dataURI = theFile.target.result;
                        //make a new image element with the dataURI as the source
                        var img = document.createElement("img");
                        img.src = dataURI;

                        //Insert the image at the carat

                        // Try the standards-based way first. This works in FF
                        if (document.caretPositionFromPoint) {
                            var pos = document.caretPositionFromPoint(x, y);
                            range = document.createRange();
                            range.setStart(pos.offsetNode, pos.offset);
                            range.collapse();
                            range.insertNode(img);
                            duToImg();
                        }
                        // Next, the WebKit way. This works in Chrome.
                        else if (document.caretRangeFromPoint) {
                            range = document.caretRangeFromPoint(x, y);
                            range.insertNode(img);
                            duToImg();
                        }
                        else
                        {
                            //not supporting IE right now.
                            console.log('could not find carat');
                        }
                        

                    });
                    //this reads in the file, and the onload event triggers, which adds the image to the div at the carat
                    reader.readAsDataURL(file);
                }
            };


(function ( $ ) {
    $.fn.CrowlMiniEditor = function(options) {
        var settings = $.extend({
            // These are the defaults.
            className: "CrowlMiniEditor",
            imageFolder: "",
            boldBtn : '<i class="fa fa-bold" aria-hidden="true"></i>',
            olBtn: '<i class="fa fa-list-ol" aria-hidden="true"></i>',
            ulBtn: '<i class="fa fa-list-ul" aria-hidden="true"></i>',
            linkBtn: '<i class="fa fa-link" aria-hidden="true"></i>',
            removeformatBtn: '<i class="fa fa-eraser" aria-hidden="true"></i>',
            htmlBtn: '<i class="fa fa-code" aria-hidden="true"></i>',
            italicBtn: '<i class="fa fa-italic" aria-hidden="true"></i>',
            underlineBtn: '<i class="fa fa-underline" aria-hidden="true"></i>',
            cutBtn: '<i class="fa fa-scissors" aria-hidden="true"></i>',
            pasteBtn: '<i class="fa fa-clipboard" aria-hidden="true"></i>',
            saveBtn: '<i class="fa fa-floppy-o" aria-hidden="true"></i>'
        }, options );
        
        CEMImageFolder = settings.imageFolder;
        
        $("<link>").prop("rel", "stylesheet").prop("href", "//netdna.bootstrapcdn.com/font-awesome/4.6.2/css/font-awesome.css").appendTo("head");
    
        $("<style>")
            .prop("type", "text/css")
            .html("\.CrowlMiniEditor img{\
                        max-width:100%;\
                    }\
                    body{\
                        position:relative;\
                    }\
                    .CMEbtn{\
                        padding:0px 10px;\
                        background-color:black;\
                        color:white;\
                    }\
                    .CMEbtn:hover{\
                        padding:0px 10px;\
                        background-color:white;\
                        color:black;\
                    }\
                    .CMEModal, .IMGEDITOR{\
                        width:550px;\
                        height:370px;\
                        background-color:white;\
                        background-color:rgba(255,255,255,0.9);\
                        position:absolute;\
                        border:1px solid lightblue;\
                        z-index:400;\
                        left:50%;\
                        top:50%;\
                        padding:20px;\
                        overflow:auto;\
                        transform: translate(-50%, -50%);\
                        box-shadow:3px 3px 3px 3px rgba(0,0,0,0.4);\
                    }\
                    .CMEModal textarea{\
                        height:300px;\
                        width:100%;\
                    }\
                  .CrowlMiniEditor{\
                        padding:20px;\
                        border:1px solid lightblue;\
                        width:95%;\
                        height:300px;\
                        overflow:auto;\
                    }").appendTo("head");
        
        /*Knoppen maken*/
        
        var btnSave = $("<button/>");
        btnSave.addClass("saveme CMEbtn");
        btnSave.html(settings.saveBtn);
        
        var btnBold = $("<button/>");
        btnBold.addClass("setBold CMEbtn");
        btnBold.html(settings.boldBtn);
        
        var btnItalic = $("<button/>");
        btnItalic.addClass("setItalic CMEbtn");
        btnItalic.html(settings.italicBtn);
        
        var btnUnderline = $("<button/>");
        btnUnderline.addClass("setUnderline CMEbtn");
        btnUnderline.html(settings.underlineBtn);
        
        var btnH1 = $("<button/>");
        btnH1.addClass("setH1 CMEbtn");
        btnH1.text("H1");
        
        var btnH2 = $("<button/>");
        btnH2.addClass("setH2 CMEbtn");
        btnH2.text("H2");
        
        var btnH3 = $("<button/>");
        btnH3.addClass("setH3 CMEbtn");
        btnH3.text("H3");
        
        var btnLINK = $("<button/>");
        btnLINK.addClass("setLink CMEbtn");
        btnLINK.html(settings.linkBtn);
        
        var btnHTML = $("<button/>");
        btnHTML.addClass("setHTML CMEbtn");
        btnHTML.html(settings.htmlBtn);
        
        var btnOL = $("<button/>");
        btnOL.addClass("setOL CMEbtn");
        btnOL.html(settings.olBtn);
        
        var btnUL = $("<button/>");
        btnUL.addClass("setUL CMEbtn");
        btnUL.html(settings.ulBtn);
        
        var btnCUT = $("<button/>");
        btnCUT.addClass("cutme CMEbtn");
        btnCUT.html(settings.cutBtn);
        
        var btnPASTE = $("<button/>");
        btnPASTE.addClass("pasteit CMEbtn");
        btnPASTE.html(settings.pasteBtn);
        
        var btnRF = $("<button/>");
        btnRF.addClass("remFM CMEbtn");
        btnRF.html(settings.removeformatBtn);
        
        var UPL = $("<span/>");
        UPL.addClass("uploadspan");
        UPL.html(IMGUPLOADTPL);
        
        /*einde knoppen*/
        
        return this.each( function() {
            var ta = $(this);
            $(this).css("display", "none");
            var editor = $("<div/>");
            editor.attr("contenteditable", "true");
            editor.addClass(settings.className);
            $(this).after(editor);
            editor.addClass("mysmallcrowleditor");
            
            editor.on("click, keydown, keyup", function(){
                var element = editor[0];
                CMECaret = getCaret(element);
            });
            
            /*knoppenbalk genereren*/
            editor.before(btnSave);
            editor.before(btnBold);
            editor.before(btnItalic);
            editor.before(btnUnderline);
            editor.before(btnH1);
            editor.before(btnH2);
            editor.before(btnH3);
            editor.before(btnLINK);
            editor.before(btnHTML);
            editor.before(btnOL);
            editor.before(btnUL);
            editor.before(UPL);
            editor.before(btnCUT);
            editor.before(btnPASTE);
            editor.before(btnRF);
            
            var placeholder = $("<span/>");
            placeholder.css("display", "none");
            placeholder.attr("id", "CMEplaceholder");
            placeholder.html("<img src=''/>");
            editor.before(placeholder);
            
            
            $(".CUPL").on("click", function(e){
                e.preventDefault();
                
                var fileselect= $(this).prev("input");
                fileselect.click();
                fileselect.on("change", function(){
                    var reader = new FileReader();
                    reader.onload = function (e) {
                        $("#CMEplaceholder").find("img").attr("src", e.target.result);
                        var element = editor[0];
                        var sc = setCaret(element, CMECaret);
                        var h = $("#CMEplaceholder").html();
                        if(sc){
                            document.execCommand("insertHTML", false, h);
                            duToImg();
                        }
                        
                        
                    };
                    reader.readAsDataURL(this.files[0]);
                });
            });
            
            
            $(".saveme").on("click", function(e){
                $(this).closest("form").submit();
            });

            $(".remFM").on("click", function(e){
                e.preventDefault();
                var container = null;
                if (document.selection){
                    container = document.selection.createRange().parentElement();
                }else {
                    var select = window.getSelection();
                    if (select.rangeCount > 0){
                        container = select.getRangeAt(0).startContainer.parentNode;
                    }
                }
                var chclass = $(container).attr("class");
                if (typeof chclass !== "undefined" && chclass.indexOf("mysmallcrowleditor") > -1){
                    
                }else{
                    $(container).contents().unwrap();
                }

                document.execCommand("removeformat", false, "");
            });
            
            $(".setBold").on("click", function(e){
                e.preventDefault();
                document.execCommand("bold");
            });
            $(".setItalic").on("click", function(e){
                e.preventDefault();
                document.execCommand("italic");
            });
            $(".setUnderline").on("click", function(e){
                e.preventDefault();
                document.execCommand("underline");
            });
            $(".setOL").on("click", function(e){
                e.preventDefault();
                document.execCommand("insertOrderedList");
            });
            $(".setUL").on("click", function(e){
                e.preventDefault();
                document.execCommand("insertUnorderedList");
            });
            $(".setH1").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h1>');
            });
            $(".setH2").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h2>');
            });
            $(".setH3").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h3>');
            });
            $(".setLink").on("click", function(e){
                e.preventDefault();
                CEMCreateLink();
            });
            $(".cutme").on("click", function(e){
                e.preventDefault();
                document.execCommand("cut");
            });
            $(".pasteit").on("click", function(e){
                e.preventDefault();
                document.execCommand("paste");
                alert("Gebruik CTRL+V (Linux of Windows) of CMD+V (Mac OS)");
            });
            $(".setHTML").on("click", function(e){
                e.preventDefault();
                var window = $("<div/>");
                window.addClass("CMEModal");
                window.html("<textarea></textarea><button class='CMEInsertHTML'>Voeg toe</button>");
                $("body").append(window);
                $(".CMEInsertHTML").on("click", function(e){
                    e.preventDefault();
                    var h = $(this).prev("textarea").val();
                    var element = editor[0];
                    var sc = setCaret(element, CMECaret);
                    if(sc){
                        document.execCommand("insertHTML", false, h);
                    }
                    //document.execCommand("insertHTML", true, h);
                    $(".CMEModal").remove();
                });
            });
            /*einde knoppenbalk*/
            
            editor[0].addEventListener('dragover', CEMDrag, false);
            editor[0].addEventListener('drop', CEMDrop, false);
            
            ta.closest("form").on("submit", function(e){
                e.preventDefault();
                var html = editor.html();
                ta.val(html);
                $(this).unbind("submit").submit();
            });
        });
    }; 
}( jQuery ));


(function ( $ ) {
    $.fn.CrowlImageDrop = function(options) {
        var settings = $.extend({
            // These are the defaults.
            className: "CrowlImageDrop",
            imageFolder: "",
            multiple: true
        }, options );
        
        CEMImageFolder = settings.imageFolder;
        CEMImageDropMultiple = settings.multiple;
        
        $("<style>")
            .prop("type", "text/css")
            .html("\.CrowlImageDrop img{\
                        max-width:20%;\
                        margin:20px;\
                    }\
                  .CrowlImageDrop{\
                        padding:0px;\
                        border:1px solid lightblue;\
                        width:95%;\
                        height:100px;\
                        overflow:auto;\
                    }").appendTo("head");
        
        return this.each( function() {
            var ta = $(this);
            //$(this).css("display", "none");
            var editor = $("<div/>");
            editor.attr("contenteditable", "true");
            editor.addClass(settings.className);
            $(this).after(editor);
            editor.addClass("mysmallcrowleditor").addClass("mysmallcrowlimagedropper");
            
            editor[0].addEventListener('dragover', CEMDrag, false);
            editor[0].addEventListener('drop', CEMDrop, false);
            
            editor.keypress(function(event){
                event.preventDefault();
            });
            
            editor.bind('copy paste cut',function(e){
                e.preventDefault();
                alert("Plakken niet toegestaan");
            });
            
            ta.closest("form").on("submit", function(e){
                e.preventDefault();
                editor.find("*").not("img").remove();
                var html = editor.find("img:first").attr("src");
                ta.val(html);
                $(this).unbind("submit").submit();
            });
        });
    }; 
}( jQuery ));